﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
//using Microsoft.Xna.Framework.Audio;
//using Microsoft.Xna.Framework.Content;
//using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
//using Microsoft.Xna.Framework.Input;
//using Microsoft.Xna.Framework.Media;
//using Microsoft.Xna.Framework.Net;
//using Microsoft.Xna.Framework.Storage;

namespace GridTest
{
    class Shapes
    {
        //Generic shape class
        //Created by Stephen Ancell (22 August 2009)
        //A bit kludgy, but at least it works eh !
        //Usage: Something like...
        
        /*
        spriteBatch.Begin();
        //Replace true with false, if you don't want the rectangle to be filled.
        Shapes.Rect(graphics.GraphicsDevice, spriteBatch, int x, int y, int width, int height, Color.Red, false);
        spriteBatch.End();
        */

        public static void Rect(GraphicsDevice g, SpriteBatch s, int x, int y, int w, int h, Color c, bool filled)
        {
            //Idiot-Proofing
            //Not suggesting that you are one, we all make mistakes
            //To avoid errors if the width or height is less than 1
            if (w < 1)
                return;
            if (h < 1)
                return;

            //This will set the position to where you want it on the screen
            Vector2 pos = new Vector2(x, y);

            //Create a 2D Texture for the desired GraphicsDevice, to the size of your desired dimensions
            Texture2D texture = new Texture2D(g, w, h);

            //Create an array of Colors, to the size of your desired dimensions
            Color[] color = new Color[texture.Width * texture.Height];

            //Unfilled rectangle section
            //Fill the top horizontal line with texel/pixel color data
            for (int across = 0; across <= 0 + (w - 1); across++)
            {
                color[across] = c;
            }

            //Fill the bottom horizontal line with texel/pixel color data
            for (int across = 0; across <= 0 + (w - 1); across++)
            {
                color[across + w * (h - 1)] = c;
            }

            //Fill the left vertical line with texel/pixel color data
            for (int down = 0; down <= 0 + (h - 1); down++)
            {
                color[down * w] = c;
            }

            //Fill the right vertical line with texel/pixel color data
            for (int down = 0; down <= 0 + (h - 1); down++)
            {
                color[(down * w) + (w - 1)] = c;
            }

            //Filled rectangle section
            //Fill the whole array with texel/pixel color data
            if (filled == true)
            {
                int i = 0;
                for (int down = 0; down <= (h - 1); down++)
                {
                    for (int across = 0; across <= (w - 1); across++)
                    {
                        color[i] = c;
                        i++;
                    }
                }
            }

            //Dump the texel/pixel color data from the array, into the created 2D Texture
            texture.SetData(color);

            //Draw the 2D Texture for the desired SpriteBatch
            s.Draw(texture, pos, Color.White);
        }
    }
}
